Proxmox/setup/heimdalldashboard-install.sh

127 lines
3.3 KiB
Bash
Raw Normal View History

2022-04-25 17:09:20 +02:00
#!/usr/bin/env bash
2022-04-18 17:13:47 +02:00
YW=`echo "\033[33m"`
2022-03-23 20:00:18 +01:00
RD=`echo "\033[01;31m"`
BL=`echo "\033[36m"`
GN=`echo "\033[1;92m"`
CL=`echo "\033[m"`
RETRY_NUM=10
RETRY_EVERY=3
NUM=$RETRY_NUM
2022-04-18 17:13:47 +02:00
CM="${GN}${CL}"
CROSS="${RD}${CL}"
BFR="\\r\\033[K"
HOLD="-"
2022-04-25 17:09:20 +02:00
set -o errexit
set -o errtrace
set -o nounset
set -o pipefail
shopt -s expand_aliases
alias die='EXIT=$? LINE=$LINENO error_exit'
trap die ERR
function error_exit() {
trap - ERR
local reason="Unknown failure occured."
local msg="${1:-$reason}"
local flag="${RD}‼ ERROR ${CL}$EXIT@$LINE"
echo -e "$flag $msg" 1>&2
exit $EXIT
}
2022-04-18 17:13:47 +02:00
function msg_info() {
local msg="$1"
echo -ne " ${HOLD} ${YW}${msg}..."
}
function msg_ok() {
local msg="$1"
echo -e "${BFR} ${CM} ${GN}${msg}${CL}"
}
2022-03-23 20:00:18 +01:00
2022-04-18 17:13:47 +02:00
msg_info "Setting up Container OS "
2022-03-23 20:00:18 +01:00
sed -i "/$LANG/ s/\(^# \)//" /etc/locale.gen
locale-gen >/dev/null
while [ "$(hostname -I)" = "" ]; do
1>&2 echo -en "${CROSS}${RD} No Network! "
sleep $RETRY_EVERY
((NUM--))
if [ $NUM -eq 0 ]
then
1>&2 echo -e "${CROSS}${RD} No Network After $RETRY_NUM Tries${CL}"
exit 1
fi
done
2022-04-18 17:13:47 +02:00
msg_ok "Set up Container OS"
msg_ok "Network Connected: ${BL}$(hostname -I)"
2022-03-23 20:00:18 +01:00
2022-04-18 17:13:47 +02:00
msg_info "Updating Container OS"
2022-03-23 20:00:18 +01:00
apt update &>/dev/null
apt-get -qqy upgrade &>/dev/null
2022-04-18 17:13:47 +02:00
msg_ok "Updated Container OS"
2022-03-23 20:00:18 +01:00
2022-04-18 17:13:47 +02:00
msg_info "Installing Dependencies"
2022-03-23 20:00:18 +01:00
apt-get install -y curl &>/dev/null
apt-get install -y sudo &>/dev/null
2022-04-18 17:13:47 +02:00
msg_ok "Installed Dependencies"
2022-03-23 20:00:18 +01:00
2022-04-18 17:13:47 +02:00
msg_info "Installing PHP"
2022-03-23 20:00:18 +01:00
apt-get install -y php &>/dev/null
apt-get install -y php-sqlite3 &>/dev/null
apt-get install -y php-zip &>/dev/null
2022-04-18 17:13:47 +02:00
msg_ok "Installed PHP"
2022-03-23 20:00:18 +01:00
2022-03-23 20:10:38 +01:00
RELEASE=$(curl -sX GET "https://api.github.com/repos/linuxserver/Heimdall/releases/latest" | awk '/tag_name/{print $4;exit}' FS='[""]')
2022-04-18 17:13:47 +02:00
msg_info "Installing Heimdall Dashboard ${RELEASE}"
2022-03-27 19:50:16 +02:00
curl --silent -o ${RELEASE}.tar.gz -L "https://github.com/linuxserver/Heimdall/archive/${RELEASE}.tar.gz" &>/dev/null
2022-03-23 20:10:38 +01:00
tar xvzf ${RELEASE}.tar.gz &>/dev/null
2022-03-27 19:50:16 +02:00
VER=$(curl -s https://api.github.com/repos/linuxserver/Heimdall/releases/latest \
2022-03-26 23:33:38 +01:00
| grep "tag_name" \
| awk '{print substr($2, 3, length($2)-4) }')
2022-03-27 19:50:16 +02:00
rm -rf ${RELEASE}.tar.gz
mv Heimdall-${VER} /opt/Heimdall
2022-04-18 17:13:47 +02:00
msg_ok "Installed Heimdall Dashboard ${RELEASE}"
2022-03-26 23:33:38 +01:00
2022-04-18 17:13:47 +02:00
msg_info "Creating Service"
2022-03-23 20:00:18 +01:00
service_path="/etc/systemd/system/heimdall.service"
echo "[Unit]
Description=Heimdall
After=network.target
[Service]
Restart=always
RestartSec=5
Type=simple
User=root
2022-03-27 19:50:16 +02:00
WorkingDirectory=/opt/Heimdall
2022-03-23 20:00:18 +01:00
ExecStart="/usr/bin/php" artisan serve --port 7990 --host 0.0.0.0
TimeoutStopSec=30
[Install]
WantedBy=multi-user.target" > $service_path
sudo systemctl enable --now heimdall.service &>/dev/null
2022-04-18 17:13:47 +02:00
msg_ok "Created Service"
2022-03-23 20:00:18 +01:00
PASS=$(grep -w "root" /etc/shadow | cut -b6);
if [[ $PASS != $ ]]; then
2022-04-18 17:13:47 +02:00
msg_info "Customizing Container"
2022-03-23 20:00:18 +01:00
rm /etc/motd
rm /etc/update-motd.d/10-uname
touch ~/.hushlogin
GETTY_OVERRIDE="/etc/systemd/system/container-getty@1.service.d/override.conf"
mkdir -p $(dirname $GETTY_OVERRIDE)
cat << EOF > $GETTY_OVERRIDE
[Service]
ExecStart=
ExecStart=-/sbin/agetty --autologin root --noclear --keep-baud tty%I 115200,38400,9600 \$TERM
EOF
systemctl daemon-reload
systemctl restart $(basename $(dirname $GETTY_OVERRIDE) | sed 's/\.d//')
2022-04-18 17:13:47 +02:00
msg_ok "Customized Container"
2022-03-23 20:00:18 +01:00
fi
2022-04-18 17:13:47 +02:00
msg_info "Cleaning up"
2022-03-23 20:00:18 +01:00
apt-get autoremove >/dev/null
apt-get autoclean >/dev/null
rm -rf /var/{cache,log}/* /var/lib/apt/lists/*
2022-04-18 17:13:47 +02:00
msg_ok "Cleaned"